diff --git a/configure.ac b/configure.ac
index 117d788..2ff6020 100644
--- a/configure.ac
+++ b/configure.ac
@@ -203,6 +203,18 @@ AM_CONDITIONAL(CK_COMPILE_SOLARIS, test x$CK_BACKEND = xsolaris, [Compiling for
 AC_SUBST(CK_BACKEND)
 
 dnl ---------------------------------------------------------------------------
+dnl Check for X11 DIR
+dnl ---------------------------------------------------------------------------
+
+X11_DIR=`$PKG_CONFIG --variable=bindir xorg-server 2>/dev/null`
+if test "x$X11_DIR" = x; then
+    AC_PATH_PROGS([XSERVER], [Xorg X],,[$PATH:/usr/X11/bin:/usr/bin])
+    test "x$XSERVER" != x && X11_DIR=`dirname "$XSERVER"`
+fi
+test "x$X11_DIR" = x && X11_DIR=$bindir
+AC_SUBST([X11_DIR])
+
+dnl ---------------------------------------------------------------------------
 dnl Check for PAM
 dnl ---------------------------------------------------------------------------
 
@@ -303,6 +315,14 @@ if test "x$enable_inotify" = "xyes" ; then
 fi
 
 dnl ---------------------------------------------------------------------------
+dnl check for strverscmp
+dnl ---------------------------------------------------------------------------
+have_strverscmp=no
+AC_CHECK_FUNCS(strverscmp, [have_strverscmp=yes], [])
+
+AM_CONDITIONAL(USE_SELF_STRVERSCMP, test "x$have_strverscmp" = "xno", [Define if we do not have strverscmp])
+
+dnl ---------------------------------------------------------------------------
 dnl check for RBAC
 dnl ---------------------------------------------------------------------------
 
@@ -401,6 +421,8 @@ tools/linux/Makefile
 tools/freebsd/Makefile
 tools/solaris/Makefile
 data/Makefile
+data/displays.d/Makefile
+data/sessions.d/Makefile
 doc/Makefile
 doc/dbus/ConsoleKit.xml
 doc/dbus/Makefile
diff --git a/data/00-primary.seat b/data/00-primary.seat
index 6e61db4..0632382 100644
--- a/data/00-primary.seat
+++ b/data/00-primary.seat
@@ -1,5 +1,26 @@
 [Seat Entry]
 Version=1.0
 Name=Primary seat
+# Specified Seat ID, if this value is NULL, ConsoleKit will decide one.
+# The ID only contain the ASICC characters "[A-Z][a-z][0-9]_" 
+ID=StaticSeat1
+Description=start one static local display at :0
+
+# Indicate whether to create this seat or not. If it is set true, then CK will
+# not create this seat. Default value is false.
 Hidden=false
-Devices=
\ No newline at end of file
+
+# Indicate input/output devices including keyboard-pointer-video
+# card-monitor-sound-usb devices,
+# This key will not implemented now, it might need be divided into
+# several keys in the future:
+# Pointer=
+# Monitor=
+# VideoCard=
+# Monitor=
+# UsbHub=
+Devices=
+
+# List of sessions to start on the seat, separated by ';'
+# Each session is defined in sessions.d/
+Sessions=Local;
diff --git a/data/ConsoleKit.conf b/data/ConsoleKit.conf
index 948f95f..8cf490a 100644
--- a/data/ConsoleKit.conf
+++ b/data/ConsoleKit.conf
@@ -44,6 +44,9 @@
            send_member="CloseSession"/>
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Manager"
+           send_member="GetUnmanagedSeats"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Manager"
            send_member="GetSeats"/>
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Manager"
@@ -69,6 +72,18 @@
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Manager"
            send_member="GetSystemIdleSinceHint"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Manager"
+           send_member="AddSeat"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Manager"
+           send_member="RemoveSeat"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Manager"
+           send_member="AddSession"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Manager"
+           send_member="RemoveSession"/>
 
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Seat"
@@ -88,6 +103,9 @@
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Seat"
            send_member="ActivateSession"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Seat"
+           send_member="ManageSeat"/>
 
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Session"
@@ -103,6 +121,9 @@
            send_member="GetSessionType"/>
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Session"
+           send_member="GetDisplayType"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Session"
            send_member="GetUser"/>
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Session"
@@ -127,6 +148,12 @@
            send_member="IsLocal"/>
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Session"
+           send_member="IsDynamic"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Session"
+           send_member="IsOpen"/>
+    <allow send_destination="org.freedesktop.ConsoleKit"
+           send_interface="org.freedesktop.ConsoleKit.Session"
            send_member="GetCreationTime"/>
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Session"
@@ -136,12 +163,11 @@
            send_member="GetIdleHint"/>
     <allow send_destination="org.freedesktop.ConsoleKit"
            send_interface="org.freedesktop.ConsoleKit.Session"
-           send_member="SetIdleHint"/>
-    <allow send_destination="org.freedesktop.ConsoleKit"
-           send_interface="org.freedesktop.ConsoleKit.Session"
            send_member="GetIdleSinceHint"/>
     <allow send_interface="org.freedesktop.ConsoleKit.Session"
            send_member="SetIdleHint"/>
+    <allow send_interface="org.freedesktop.ConsoleKit.Session"
+           send_member="SetRemoveOnClose"/>
   </policy>
 
 </busconfig>
diff --git a/data/Makefile.am b/data/Makefile.am
index 041b431..2054e96 100644
--- a/data/Makefile.am
+++ b/data/Makefile.am
@@ -1,5 +1,10 @@
 NULL =
 
+SUBDIRS = \
+	displays.d	\
+	sessions.d	\
+        $(NULL)
+
 dbusconfdir = $(DBUS_SYS_DIR)
 dbusconf_DATA = ConsoleKit.conf
 
diff --git a/data/displays.d/Headless.display.in b/data/displays.d/Headless.display.in
new file mode 100644
index 0000000..754d2bf
--- /dev/null
+++ b/data/displays.d/Headless.display.in
@@ -0,0 +1,5 @@
+[Display]
+Type=X11
+
+[X11]
+Exec=@X11_DIR@/Xvfb $display -auth $auth
diff --git a/data/displays.d/Local.display.in b/data/displays.d/Local.display.in
new file mode 100644
index 0000000..b845a7b
--- /dev/null
+++ b/data/displays.d/Local.display.in
@@ -0,0 +1,5 @@
+[Display]
+Type=X11
+
+[X11]
+Exec=@X11_DIR@/Xorg $display -br -verbose -auth $auth -nolisten tcp $vt
diff --git a/data/displays.d/LocalVNC.display.in b/data/displays.d/LocalVNC.display.in
new file mode 100644
index 0000000..6ad336b
--- /dev/null
+++ b/data/displays.d/LocalVNC.display.in
@@ -0,0 +1,5 @@
+[Display]
+Type=X11
+
+[X11]
+Exec=@X11_DIR@/Xvnc $display -auth $auth -query localhost
diff --git a/data/displays.d/Makefile.am b/data/displays.d/Makefile.am
new file mode 100644
index 0000000..1fab1d2
--- /dev/null
+++ b/data/displays.d/Makefile.am
@@ -0,0 +1,29 @@
+NULL =
+
+displaydir = $(sysconfdir)/ConsoleKit/displays.d
+display_in_files = \
+	Local.display.in \
+	RemoteMachine.display.in \
+	LocalVNC.display.in \
+	Headless.display.in
+
+display_DATA = $(display_in_files:.display.in=.display)
+
+Local.display: Local.display.in Makefile
+	sed -e "s|\@X11_DIR\@|$(X11_DIR)|" $< > $@
+RemoteMachine.display: RemoteMachine.display.in Makefile
+	sed -e "s|\@X11_DIR\@|$(X11_DIR)|" $< > $@
+LocalVNC.display: LocalVNC.display.in Makefile
+	sed -e "s|\@X11_DIR\@|$(X11_DIR)|" $< > $@
+Headless.display: Headless.display.in Makefile
+	sed -e "s|\@X11_DIR\@|$(X11_DIR)|" $< > $@
+
+EXTRA_DIST =						\
+	$(display_in_files)				\
+	$(NULL)
+
+MAINTAINERCLEANFILES =			\
+	*~				\
+	Makefile.in
+
+CLEANFILES = $(display_DATA)
diff --git a/data/displays.d/RemoteMachine.display.in b/data/displays.d/RemoteMachine.display.in
new file mode 100644
index 0000000..7c69451
--- /dev/null
+++ b/data/displays.d/RemoteMachine.display.in
@@ -0,0 +1,5 @@
+[Display]
+Type=X11
+
+[X11]
+Exec=@X11_DIR@/Xorg $display -br -verbose -auth $auth -indirect $vt
diff --git a/data/sessions.d/Headless.session b/data/sessions.d/Headless.session
new file mode 100644
index 0000000..d376af9
--- /dev/null
+++ b/data/sessions.d/Headless.session
@@ -0,0 +1,8 @@
+[Session Entry]
+Name=Headless
+Type=LoginWindow
+Description=Login Window running on headless display
+DisplayTemplate=Headless
+
+[Headless]
+display=:32
diff --git a/data/sessions.d/Local.session b/data/sessions.d/Local.session
new file mode 100644
index 0000000..9d3b975
--- /dev/null
+++ b/data/sessions.d/Local.session
@@ -0,0 +1,9 @@
+[Session Entry]
+Name=Local
+Type=LoginWindow
+Description=Local Login Screen
+DisplayTemplate=Local
+
+[Local]
+display=:0
+vt=vt1
diff --git a/data/sessions.d/LocalVNC.session b/data/sessions.d/LocalVNC.session
new file mode 100644
index 0000000..c05802f
--- /dev/null
+++ b/data/sessions.d/LocalVNC.session
@@ -0,0 +1,8 @@
+[Session Entry]
+Name=LocalVNC
+Type=LoginWindow
+Description=Connect to local VNC server running on same machine
+DisplayTemplate=LocalVNC
+
+[LocalVNC]
+display=:64
diff --git a/data/sessions.d/Makefile.am b/data/sessions.d/Makefile.am
new file mode 100644
index 0000000..f17ffdc
--- /dev/null
+++ b/data/sessions.d/Makefile.am
@@ -0,0 +1,16 @@
+NULL =
+
+sessiondir = $(sysconfdir)/ConsoleKit/sessions.d
+session_DATA = \
+	Headless.session		\
+	Local.session			\
+	LocalVNC.session		\
+	Remote.session
+
+EXTRA_DIST =				\
+	$(session_DATA)			\
+	$(NULL)
+
+MAINTAINERCLEANFILES =			\
+	*~				\
+	Makefile.in
diff --git a/data/sessions.d/Remote.session b/data/sessions.d/Remote.session
new file mode 100644
index 0000000..e88f975
--- /dev/null
+++ b/data/sessions.d/Remote.session
@@ -0,0 +1,9 @@
+[Session Entry]
+Name=Remote Chooser
+Type=Remote
+Description=Connect to chooser on nearby remote machine
+DisplayTemplate=RemoteMachine
+
+[RemoteMachine]
+display=:96
+vt=vt10
diff --git a/libck-connector/ck-connector.c b/libck-connector/ck-connector.c
index 7f6f87f..87a7d4a 100644
--- a/libck-connector/ck-connector.c
+++ b/libck-connector/ck-connector.c
@@ -76,8 +76,11 @@ static struct {
         { "display-device",     DBUS_TYPE_STRING },
         { "x11-display-device", DBUS_TYPE_STRING },
         { "x11-display",        DBUS_TYPE_STRING },
+        { "seat-id",            DBUS_TYPE_STRING },
+        { "session",            DBUS_TYPE_STRING },
         { "remote-host-name",   DBUS_TYPE_STRING },
         { "session-type",       DBUS_TYPE_STRING },
+        { "display-type",       DBUS_TYPE_STRING },
         { "is-local",           DBUS_TYPE_BOOLEAN },
         { "unix-user",          DBUS_TYPE_INT32 },
 };
diff --git a/src/Makefile.am b/src/Makefile.am
index 6ab05c8..97a59ef 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -107,6 +107,8 @@ console_kit_daemon_SOURCES =	\
 	ck-file-monitor.h	\
 	ck-job.h		\
 	ck-job.c		\
+	ck-display-template.h	\
+	ck-display-template.c	\
 	ck-seat.h		\
 	ck-seat.c		\
 	ck-session-leader.h	\
@@ -122,6 +124,13 @@ console_kit_daemon_SOURCES =	\
 	$(BUILT_SOURCES)	\
 	$(NULL)
 
+if USE_SELF_STRVERSCMP
+console_kit_daemon_SOURCES +=	\
+	strverscmp.c		\
+	strverscmp.h		\
+	$(NULL)
+endif
+
 if ENABLE_INOTIFY
 FILE_MONITOR_BACKEND = ck-file-monitor-inotify.c
 else
diff --git a/src/ck-display-template.c b/src/ck-display-template.c
new file mode 100644
index 0000000..9206103
--- /dev/null
+++ b/src/ck-display-template.c
@@ -0,0 +1,341 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Authors: halton.huo@sun.com, Ray Strode <rstrode@redhat.com>
+ * Copyright (C) 2009 Sun Microsystems, Inc.
+ *                    Red Hat, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+
+#include "config.h"
+
+#include <string.h>
+#include <glib.h>
+#include <glib-object.h>
+
+#include "ck-display-template.h"
+
+#define CK_DISPLAY_TEMPLATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CK_TYPE_DISPLAY_TEMPLATE, CkDisplayTemplatePrivate))
+
+#define CK_DISPLAY_TEMPLATES_DIR     SYSCONFDIR "/ConsoleKit/displays.d"
+
+struct CkDisplayTemplatePrivate
+{
+        char            *name;
+        char            *type;
+        GHashTable      *parameters;
+};
+
+enum {
+        PROP_0,
+        PROP_NAME,
+        PROP_TYPE,
+        PROP_PARAMETERS,
+};
+
+static void     ck_display_template_class_init  (CkDisplayTemplateClass *klass);
+static void     ck_display_template_init        (CkDisplayTemplate      *display);
+static void     ck_display_template_finalize    (GObject            *object);
+static gboolean ck_display_template_load        (CkDisplayTemplate      *display);
+
+static GHashTable *ck_display_templates;
+
+G_DEFINE_TYPE (CkDisplayTemplate, ck_display_template, G_TYPE_OBJECT)
+
+static void
+_ck_display_template_set_name (CkDisplayTemplate  *display,
+                               const char     *name)
+{
+        g_free (display->priv->name);
+        display->priv->name = g_strdup (name);
+}
+
+static void
+_ck_display_template_set_type_string (CkDisplayTemplate  *display,
+                                      const char     *type)
+{
+        g_free (display->priv->type);
+        display->priv->type = g_strdup (type);
+}
+
+static void
+_ck_display_template_set_parameters (CkDisplayTemplate  *display,
+                                     GHashTable     *parameters)
+{
+        if (display->priv->parameters != NULL) {
+                g_hash_table_unref (display->priv->parameters);
+        }
+
+        if (parameters == NULL) {
+                display->priv->parameters = g_hash_table_new_full (g_str_hash, g_str_equal,
+                                                                   (GDestroyNotify) g_free,
+                                                                   (GDestroyNotify) g_free);
+        } else {
+                display->priv->parameters = g_hash_table_ref (parameters);
+        }
+}
+
+static void
+ck_display_template_set_property (GObject      *object,
+                                  guint         prop_id,
+                                  const GValue *value,
+                                  GParamSpec   *pspec)
+{
+        CkDisplayTemplate *self;
+
+        self = CK_DISPLAY_TEMPLATE (object);
+
+        switch (prop_id) {
+        case PROP_NAME:
+                _ck_display_template_set_name (self, g_value_get_string (value));
+                break;
+        case PROP_TYPE:
+                _ck_display_template_set_type_string (self, g_value_get_string (value));
+                break;
+        case PROP_PARAMETERS:
+                _ck_display_template_set_parameters (self, g_value_get_boxed (value));
+                break;
+        default:
+                G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
+                break;
+        }
+}
+
+static void
+ck_display_template_get_property (GObject    *object,
+                                  guint       prop_id,
+                                  GValue     *value,
+                                  GParamSpec *pspec)
+{
+        CkDisplayTemplate *self;
+
+        self = CK_DISPLAY_TEMPLATE (object);
+
+        switch (prop_id) {
+        case PROP_NAME:
+                g_value_set_string (value, self->priv->name);
+                break;
+        case PROP_TYPE:
+                g_value_set_string (value, self->priv->type);
+                break;
+        case PROP_PARAMETERS:
+                g_value_set_boxed (value, self->priv->parameters);
+                break;
+        default:
+                G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
+                break;
+        }
+}
+
+static void
+ck_display_template_class_init (CkDisplayTemplateClass *klass)
+{
+        GObjectClass   *object_class = G_OBJECT_CLASS (klass);
+
+        object_class->get_property = ck_display_template_get_property;
+        object_class->set_property = ck_display_template_set_property;
+        object_class->finalize = ck_display_template_finalize;
+
+        g_object_class_install_property (object_class,
+                                         PROP_NAME,
+                                         g_param_spec_string ("name",
+                                                              "display type name",
+                                                              "display type name",
+                                                              NULL,
+                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
+        g_object_class_install_property (object_class,
+                                         PROP_TYPE,
+                                         g_param_spec_string ("type",
+                                                              "type",
+                                                              "Type",
+                                                              NULL,
+                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+        g_object_class_install_property (object_class,
+                                         PROP_PARAMETERS,
+                                         g_param_spec_boxed ("parameters",
+                                                              "Parameters",
+                                                              "Parameters",
+                                                              G_TYPE_HASH_TABLE,
+                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+        g_type_class_add_private (klass, sizeof (CkDisplayTemplatePrivate));
+}
+
+static void
+ck_display_template_init (CkDisplayTemplate *display)
+{
+        display->priv = CK_DISPLAY_TEMPLATE_GET_PRIVATE (display);
+
+        display->priv->name = NULL;
+        display->priv->type = NULL;
+        display->priv->parameters = g_hash_table_new_full (g_str_hash, g_str_equal,
+                                                           (GDestroyNotify) g_free,
+                                                           (GDestroyNotify) g_free);
+}
+
+static void
+ck_display_template_finalize (GObject *object)
+{
+        CkDisplayTemplate *display;
+
+        g_return_if_fail (object != NULL);
+        g_return_if_fail (CK_IS_DISPLAY_TEMPLATE (object));
+
+        display = CK_DISPLAY_TEMPLATE (object);
+
+        g_return_if_fail (display->priv != NULL);
+
+        g_free (display->priv->name);
+        g_free (display->priv->type);
+        g_hash_table_unref (display->priv->parameters);
+
+        G_OBJECT_CLASS (ck_display_template_parent_class)->finalize (object);
+}
+
+static gboolean
+ck_display_template_load (CkDisplayTemplate *display)
+{
+        GKeyFile   *key_file;
+        const char *name;
+        char       *group;
+        char       *filename;
+        gboolean    hidden;
+        char       *type;
+        gboolean    res;
+        GError     *error;
+        char      **type_keys;
+        GHashTable *parameters;
+
+        name = ck_display_template_get_name (display);
+
+        g_return_val_if_fail (name && !g_str_equal (name, ""), FALSE);
+
+        filename = g_strdup_printf ("%s/%s.display", CK_DISPLAY_TEMPLATES_DIR, name);
+
+        key_file = g_key_file_new ();
+
+        error = NULL;
+        res = g_key_file_load_from_file (key_file,
+                                         filename,
+                                         G_KEY_FILE_NONE,
+                                         &error);
+        if (! res) {
+                g_warning ("Unable to load display from file %s: %s", filename, error->message);
+                g_error_free (error);
+                return FALSE;
+        }
+        g_free (filename);
+
+        group = g_key_file_get_start_group (key_file);
+
+        if (group == NULL || strcmp (group, "Display") != 0) {
+                g_warning ("Not a display type file: %s", filename);
+                g_free (group);
+                g_key_file_free (key_file);
+                return FALSE;
+        }
+
+        hidden = g_key_file_get_boolean (key_file, group, "Hidden", NULL);
+
+        type = g_key_file_get_string (key_file, group, "Type", NULL);
+
+        if (type == NULL) {
+                g_warning ("Unable to read type from display file");
+                g_free (group);
+                g_key_file_free (key_file);
+                return FALSE;
+        }
+
+        display->priv->type = type;
+
+        parameters = g_hash_table_new_full (g_str_hash, g_str_equal,
+                                            (GDestroyNotify) g_free,
+                                            (GDestroyNotify) g_free);
+
+        type_keys = g_key_file_get_keys (key_file, type, NULL, NULL);
+
+        if (type_keys != NULL) {
+                int        i;
+                for (i = 0; type_keys[i] != NULL; i++) {
+                        char   *string;
+
+                        string = g_key_file_get_string (key_file, type, type_keys[i], NULL);
+                        g_hash_table_insert (parameters, g_strdup (type_keys[i]), string);
+                }
+                g_strfreev (type_keys);
+        }
+
+        _ck_display_template_set_parameters (display, parameters);
+        g_hash_table_unref (parameters);
+
+        g_free (group);
+        g_key_file_free (key_file);
+        return TRUE;
+}
+
+CkDisplayTemplate *
+ck_display_template_get_from_name (const char *name)
+{
+        CkDisplayTemplate *display_template;
+
+        if (ck_display_templates == NULL) {
+                ck_display_templates = g_hash_table_new_full (g_str_hash, g_str_equal,
+                                                          (GDestroyNotify) g_free,
+                                                          (GDestroyNotify) g_object_unref);
+        }
+
+        display_template = g_hash_table_lookup (ck_display_templates, name);
+
+        if (display_template == NULL) {
+                GObject *object;
+
+                object = g_object_new (CK_TYPE_DISPLAY_TEMPLATE,
+                                       "name", name,
+                                       NULL);
+
+                if (!ck_display_template_load (CK_DISPLAY_TEMPLATE (object))) {
+                        g_object_unref (object);
+                        return NULL;
+                }
+
+                g_hash_table_insert (ck_display_templates, g_strdup (name), object);
+                display_template = CK_DISPLAY_TEMPLATE (object);
+        }
+
+        return g_object_ref (display_template);
+}
+
+G_CONST_RETURN char*
+ck_display_template_get_name (CkDisplayTemplate   *display)
+{
+        g_return_val_if_fail (CK_IS_DISPLAY_TEMPLATE (display), NULL);
+
+        return display->priv->name;
+}
+
+G_CONST_RETURN char *
+ck_display_template_get_type_string (CkDisplayTemplate  *display)
+{
+        return display->priv->type;
+}
+
+GHashTable *
+ck_display_template_get_parameters (CkDisplayTemplate   *display)
+{
+        g_return_val_if_fail (CK_IS_DISPLAY_TEMPLATE (display), NULL);
+
+        return g_hash_table_ref (display->priv->parameters);
+}
+
diff --git a/src/ck-display-template.h b/src/ck-display-template.h
new file mode 100644
index 0000000..fa74e67
--- /dev/null
+++ b/src/ck-display-template.h
@@ -0,0 +1,57 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Authors: halton.huo@sun.com
+ * Copyright (C) 2009 Sun Microsystems, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+
+#ifndef __CK_DISPLAY_TEMPLATE_H
+#define __CK_DISPLAY_TEMPLATE_H
+
+#include <glib-object.h>
+
+G_BEGIN_DECLS
+
+#define CK_TYPE_DISPLAY_TEMPLATE         (ck_display_template_get_type ())
+#define CK_DISPLAY_TEMPLATE(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), CK_TYPE_DISPLAY_TEMPLATE, CkDisplayTemplate))
+#define CK_DISPLAY_TEMPLATE_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), CK_TYPE_DISPLAY_TEMPLATE, CkDisplayTemplateClass))
+#define CK_IS_DISPLAY_TEMPLATE(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), CK_TYPE_DISPLAY_TEMPLATE))
+#define CK_IS_DISPLAY_TEMPLATE_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), CK_TYPE_DISPLAY_TEMPLATE))
+#define CK_DISPLAY_TEMPLATE_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), CK_TYPE_DISPLAY_TEMPLATE, CkDisplayTemplateClass))
+
+typedef struct CkDisplayTemplatePrivate CkDisplayTemplatePrivate;
+
+typedef struct
+{
+        GObject        parent;
+        CkDisplayTemplatePrivate *priv;
+} CkDisplayTemplate;
+
+typedef struct
+{
+        GObjectClass   parent_class;
+} CkDisplayTemplateClass;
+
+GType                 ck_display_template_get_type            (void);
+CkDisplayTemplate   * ck_display_template_get_from_name       (const char      *name);
+G_CONST_RETURN char * ck_display_template_get_name            (CkDisplayTemplate   *display);
+G_CONST_RETURN char * ck_display_template_get_type_string     (CkDisplayTemplate   *display);
+GHashTable          * ck_display_template_get_parameters      (CkDisplayTemplate   *display);
+
+G_END_DECLS
+
+#endif /* __CK_DISPLAY_TEMPLATE_H */
